blob: 531a1bd3d9b09c285f56c23696deddc93682afd8 [file] [log] [blame]
Jason Kusumabe998f42015-09-03 15:53:13 -07001#!/bin/bash
2
Amin Hassani13520932017-07-26 11:26:05 -07003#
4# Copyright (C) 2015 The Android Open Source Project
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10# http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
Jason Kusumabe998f42015-09-03 15:53:13 -070018
19# Script to generate a Brillo update for use by the update engine.
20#
21# usage: brillo_update_payload COMMAND [ARGS]
22# The following commands are supported:
23# generate generate an unsigned payload
24# hash generate a payload or metadata hash
25# sign generate a signed payload
Alex Deymo98e691c2016-02-04 21:05:45 -080026# properties generate a properties file from a payload
Amin Hassani13520932017-07-26 11:26:05 -070027# verify verify a payload by recreating a target image.
Tudor Brindusb432db82018-06-29 13:13:27 -070028# check verify a payload using paycheck (static testing)
Jason Kusumabe998f42015-09-03 15:53:13 -070029#
30# Generate command arguments:
Jason Kusuma9a4cae22015-10-08 18:17:57 -070031# --payload generated unsigned payload output file
32# --source_image if defined, generate a delta payload from the specified
33# image to the target_image
34# --target_image the target image that should be sent to clients
Amin Hassani13520932017-07-26 11:26:05 -070035# --metadata_size_file if defined, generate a file containing the size of the
36# payload metadata in bytes to the specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070037#
38# Hash command arguments:
39# --unsigned_payload the input unsigned payload to generate the hash from
40# --signature_size signature sizes in bytes in the following format:
Alex Deymo89ff9e32015-09-15 19:29:01 -070041# "size1:size2[:...]"
Jason Kusumabe998f42015-09-03 15:53:13 -070042# --payload_hash_file if defined, generate a payload hash and output to the
43# specified file
44# --metadata_hash_file if defined, generate a metadata hash and output to the
45# specified file
46#
47# Sign command arguments:
Alex Deymo89ff9e32015-09-15 19:29:01 -070048# --unsigned_payload the input unsigned payload to insert the signatures
49# --payload the output signed payload
50# --signature_size signature sizes in bytes in the following format:
51# "size1:size2[:...]"
52# --payload_signature_file the payload signature files in the following
53# format:
54# "payload_signature1:payload_signature2[:...]"
55# --metadata_signature_file the metadata signature files in the following
56# format:
57# "metadata_signature1:metadata_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -070058# --metadata_size_file if defined, generate a file containing the size of
59# the signed payload metadata in bytes to the
60# specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070061# Note that the number of signature sizes and payload signatures have to match.
Alex Deymo98e691c2016-02-04 21:05:45 -080062#
63# Properties command arguments:
64# --payload the input signed or unsigned payload
65# --properties_file the output path where to write the properties, or
66# '-' for stdout.
Amin Hassani13520932017-07-26 11:26:05 -070067# Verify command arguments:
68# --payload payload input file
69# --source_image verify payload to the specified source image.
70# --target_image the target image to verify upon.
Tudor Brindusb432db82018-06-29 13:13:27 -070071#
72# Check command arguments:
73# Symmetrical with the verify command.
Alex Deymo98e691c2016-02-04 21:05:45 -080074
Jason Kusumabe998f42015-09-03 15:53:13 -070075
Alex Deymo61e1fa82016-01-19 15:16:34 -080076# Exit codes:
77EX_UNSUPPORTED_DELTA=100
78
Jason Kusumaf514c542015-11-05 18:43:45 -080079warn() {
80 echo "brillo_update_payload: warning: $*" >&2
81}
82
Gilad Arnold957ce122015-10-14 16:02:55 -070083die() {
84 echo "brillo_update_payload: error: $*" >&2
85 exit 1
Jason Kusumabe998f42015-09-03 15:53:13 -070086}
87
Gilad Arnold957ce122015-10-14 16:02:55 -070088# Loads shflags. We first look at the default install location; then look for
Amin Hassani2a14d412018-05-31 13:01:09 -070089# crosutils (chroot); finally check our own directory.
Gilad Arnold957ce122015-10-14 16:02:55 -070090load_shflags() {
91 local my_dir="$(dirname "$(readlink -f "$0")")"
92 local path
93 for path in /usr/share/misc {/usr/lib/crosutils,"${my_dir}"}/lib/shflags; do
94 if [[ -r "${path}/shflags" ]]; then
95 . "${path}/shflags" || die "Could not load ${path}/shflags."
96 return
97 fi
98 done
99 die "Could not find shflags."
100}
101
102load_shflags
Jason Kusumabe998f42015-09-03 15:53:13 -0700103
Alex Deymoc64ffd52015-09-25 18:10:07 -0700104HELP_GENERATE="generate: Generate an unsigned update payload."
105HELP_HASH="hash: Generate the hashes of the unsigned payload and metadata used \
106for signing."
107HELP_SIGN="sign: Insert the signatures into the unsigned payload."
Alex Deymo98e691c2016-02-04 21:05:45 -0800108HELP_PROPERTIES="properties: Extract payload properties to a file."
Tudor Brindusb432db82018-06-29 13:13:27 -0700109HELP_VERIFY="verify: Verify a (signed) update payload using delta_generator."
110HELP_CHECK="check: Check a (signed) update payload using paycheck (static \
111testing)."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700112
113usage() {
114 echo "Supported commands:"
115 echo
116 echo "${HELP_GENERATE}"
117 echo "${HELP_HASH}"
118 echo "${HELP_SIGN}"
Alex Deymo98e691c2016-02-04 21:05:45 -0800119 echo "${HELP_PROPERTIES}"
Amin Hassani13520932017-07-26 11:26:05 -0700120 echo "${HELP_VERIFY}"
Tudor Brindusb432db82018-06-29 13:13:27 -0700121 echo "${HELP_CHECK}"
Alex Deymoc64ffd52015-09-25 18:10:07 -0700122 echo
123 echo "Use: \"$0 <command> --help\" for more options."
124}
125
126# Check that a command is specified.
Jason Kusumabe998f42015-09-03 15:53:13 -0700127if [[ $# -lt 1 ]]; then
Tudor Brindusb432db82018-06-29 13:13:27 -0700128 echo "Please specify a command [generate|hash|sign|properties|verify|check]"
Jason Kusumabe998f42015-09-03 15:53:13 -0700129 exit 1
130fi
131
Alex Deymoc64ffd52015-09-25 18:10:07 -0700132# Parse command.
133COMMAND="${1:-}"
134shift
135
136case "${COMMAND}" in
137 generate)
138 FLAGS_HELP="${HELP_GENERATE}"
139 ;;
140
141 hash)
142 FLAGS_HELP="${HELP_HASH}"
143 ;;
144
145 sign)
146 FLAGS_HELP="${HELP_SIGN}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700147 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800148
149 properties)
150 FLAGS_HELP="${HELP_PROPERTIES}"
151 ;;
Amin Hassani13520932017-07-26 11:26:05 -0700152
153 verify)
154 FLAGS_HELP="${HELP_VERIFY}"
155 ;;
156
Tudor Brindusb432db82018-06-29 13:13:27 -0700157 check)
158 FLAGS_HELP="${HELP_CHECK}"
159 ;;
160
Jason Kusumabe998f42015-09-03 15:53:13 -0700161 *)
Alex Deymoc64ffd52015-09-25 18:10:07 -0700162 echo "Unrecognized command: \"${COMMAND}\"" >&2
163 usage >&2
Jason Kusumabe998f42015-09-03 15:53:13 -0700164 exit 1
165 ;;
166esac
167
Jason Kusumabe998f42015-09-03 15:53:13 -0700168# Flags
Alex Deymoc64ffd52015-09-25 18:10:07 -0700169FLAGS_HELP="Usage: $0 ${COMMAND} [flags]
170${FLAGS_HELP}"
171
172if [[ "${COMMAND}" == "generate" ]]; then
173 DEFINE_string payload "" \
174 "Path to output the generated unsigned payload file."
175 DEFINE_string target_image "" \
176 "Path to the target image that should be sent to clients."
177 DEFINE_string source_image "" \
178 "Optional: Path to a source image. If specified, this makes a delta update."
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700179 DEFINE_string metadata_size_file "" \
180 "Optional: Path to output metadata size."
Sen Jiang8e768e92017-06-28 17:13:19 -0700181 DEFINE_string max_timestamp "" \
182 "Optional: The maximum unix timestamp of the OS allowed to apply this \
183payload, should be set to a number higher than the build timestamp of the \
184system running on the device, 0 if not specified."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700185fi
186if [[ "${COMMAND}" == "hash" || "${COMMAND}" == "sign" ]]; then
187 DEFINE_string unsigned_payload "" "Path to the input unsigned payload."
188 DEFINE_string signature_size "" \
189 "Signature sizes in bytes in the following format: size1:size2[:...]"
190fi
191if [[ "${COMMAND}" == "hash" ]]; then
192 DEFINE_string metadata_hash_file "" \
193 "Optional: Path to output metadata hash file."
194 DEFINE_string payload_hash_file "" \
195 "Optional: Path to output payload hash file."
196fi
197if [[ "${COMMAND}" == "sign" ]]; then
198 DEFINE_string payload "" \
199 "Path to output the generated unsigned payload file."
200 DEFINE_string metadata_signature_file "" \
201 "The metatada signatures in the following format: \
202metadata_signature1:metadata_signature2[:...]"
203 DEFINE_string payload_signature_file "" \
204 "The payload signatures in the following format: \
205payload_signature1:payload_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700206 DEFINE_string metadata_size_file "" \
207 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700208fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800209if [[ "${COMMAND}" == "properties" ]]; then
210 DEFINE_string payload "" \
211 "Path to the input signed or unsigned payload file."
212 DEFINE_string properties_file "-" \
213 "Path to output the extracted property files. If '-' is passed stdout will \
214be used."
215fi
Tudor Brindusb432db82018-06-29 13:13:27 -0700216if [[ "${COMMAND}" == "verify" || "${COMMAND}" == "check" ]]; then
Amin Hassani13520932017-07-26 11:26:05 -0700217 DEFINE_string payload "" \
218 "Path to the input payload file."
219 DEFINE_string target_image "" \
220 "Path to the target image to verify upon."
221 DEFINE_string source_image "" \
222 "Optional: Path to a source image. If specified, the delta update is \
223applied to this."
224fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800225
Alex Deymo5fbb1102017-01-12 13:55:52 -0800226DEFINE_string work_dir "${TMPDIR:-/tmp}" "Where to dump temporary files."
Jason Kusumabe998f42015-09-03 15:53:13 -0700227
228# Parse command line flag arguments
229FLAGS "$@" || exit 1
230eval set -- "${FLAGS_ARGV}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700231set -e
Jason Kusumabe998f42015-09-03 15:53:13 -0700232
Alex Deymo5fbb1102017-01-12 13:55:52 -0800233# Override the TMPDIR with the passed work_dir flags, which anyway defaults to
234# ${TMPDIR}.
235TMPDIR="${FLAGS_work_dir}"
236export TMPDIR
237
Alex Deymo89ff9e32015-09-15 19:29:01 -0700238# Associative arrays from partition name to file in the source and target
239# images. The size of the updated area must be the size of the file.
240declare -A SRC_PARTITIONS
241declare -A DST_PARTITIONS
242
Alex Deymo20bdc702016-12-07 21:07:11 -0800243# Associative arrays for the .map files associated with each src/dst partition
244# file in SRC_PARTITIONS and DST_PARTITIONS.
245declare -A SRC_PARTITIONS_MAP
246declare -A DST_PARTITIONS_MAP
247
Sen Jiang788c2d92016-03-09 12:48:40 -0800248# List of partition names in order.
249declare -a PARTITIONS_ORDER
250
Alex Deymo89ff9e32015-09-15 19:29:01 -0700251# A list of temporary files to remove during cleanup.
252CLEANUP_FILES=()
253
Alex Deymo48b502a2015-09-17 19:00:18 -0700254# Global options to force the version of the payload.
255FORCE_MAJOR_VERSION=""
256FORCE_MINOR_VERSION=""
257
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800258# Path to the postinstall config file in target image if exists.
259POSTINSTALL_CONFIG_FILE=""
260
Alex Deymoc97df432015-09-25 17:23:52 -0700261# read_option_int <file.txt> <option_key> [default_value]
262#
263# Reads the unsigned integer value associated with |option_key| in a key=value
264# file |file.txt|. Prints the read value if found and valid, otherwise prints
265# the |default_value|.
266read_option_uint() {
267 local file_txt="$1"
268 local option_key="$2"
269 local default_value="${3:-}"
270 local value
271 if value=$(look "${option_key}=" "${file_txt}" | tail -n 1); then
272 if value=$(echo "${value}" | cut -f 2- -d "=" | grep -E "^[0-9]+$"); then
273 echo "${value}"
274 return
275 fi
276 fi
277 echo "${default_value}"
278}
279
Sen Jiangd0e9a892016-07-22 16:28:07 -0700280# truncate_file <file_path> <file_size>
281#
282# Truncate the given |file_path| to |file_size| using perl.
283# The truncate binary might not be available.
284truncate_file() {
285 local file_path="$1"
286 local file_size="$2"
287 perl -e "open(FILE, \"+<\", \$ARGV[0]); \
288 truncate(FILE, ${file_size}); \
289 close(FILE);" "${file_path}"
290}
291
Alex Deymo89ff9e32015-09-15 19:29:01 -0700292# Create a temporary file in the work_dir with an optional pattern name.
293# Prints the name of the newly created file.
294create_tempfile() {
295 local pattern="${1:-tempfile.XXXXXX}"
296 mktemp --tmpdir="${FLAGS_work_dir}" "${pattern}"
297}
Jason Kusumabe998f42015-09-03 15:53:13 -0700298
299cleanup() {
300 local err=""
Alex Deymo89ff9e32015-09-15 19:29:01 -0700301 rm -f "${CLEANUP_FILES[@]}" || err=1
Jason Kusumabe998f42015-09-03 15:53:13 -0700302
303 # If we are cleaning up after an error, or if we got an error during
304 # cleanup (even if we eventually succeeded) return a non-zero exit
305 # code. This triggers additional logging in most environments that call
306 # this script.
307 if [[ -n "${err}" ]]; then
308 die "Cleanup encountered an error."
309 fi
310}
311
312cleanup_on_error() {
313 trap - INT TERM ERR EXIT
314 cleanup
315 die "Cleanup success after an error."
316}
317
318cleanup_on_exit() {
319 trap - INT TERM ERR EXIT
320 cleanup
321}
322
323trap cleanup_on_error INT TERM ERR
324trap cleanup_on_exit EXIT
325
Alex Deymo48b502a2015-09-17 19:00:18 -0700326
Sen Jiang788c2d92016-03-09 12:48:40 -0800327# extract_image <image> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700328#
329# Detect the format of the |image| file and extract its updatable partitions
330# into new temporary files. Add the list of partition names and its files to the
Sen Jiang788c2d92016-03-09 12:48:40 -0800331# associative array passed in |partitions_array|. If |partitions_order| is
332# passed, set it to list of partition names in order.
Alex Deymo48b502a2015-09-17 19:00:18 -0700333extract_image() {
334 local image="$1"
335
336 # Brillo images are zip files. We detect the 4-byte magic header of the zip
337 # file.
338 local magic=$(head --bytes=4 "${image}" | hexdump -e '1/1 "%.2x"')
339 if [[ "${magic}" == "504b0304" ]]; then
340 echo "Detected .zip file, extracting Brillo image."
341 extract_image_brillo "$@"
342 return
343 fi
344
345 # Chrome OS images are GPT partitioned disks. We should have the cgpt binary
346 # bundled here and we will use it to extract the partitions, so the GPT
347 # headers must be valid.
348 if cgpt show -q -n "${image}" >/dev/null; then
349 echo "Detected GPT image, extracting Chrome OS image."
350 extract_image_cros "$@"
351 return
352 fi
353
354 die "Couldn't detect the image format of ${image}"
355}
356
Sen Jiang788c2d92016-03-09 12:48:40 -0800357# extract_image_cros <image.bin> <partitions_array> [partitions_order]
Alex Deymo89ff9e32015-09-15 19:29:01 -0700358#
Alex Deymo48b502a2015-09-17 19:00:18 -0700359# Extract Chromium OS recovery images into new temporary files.
Alex Deymo89ff9e32015-09-15 19:29:01 -0700360extract_image_cros() {
361 local image="$1"
362 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800363 local partitions_order="${3:-}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700364
365 local kernel root
366 kernel=$(create_tempfile "kernel.bin.XXXXXX")
367 CLEANUP_FILES+=("${kernel}")
368 root=$(create_tempfile "root.bin.XXXXXX")
369 CLEANUP_FILES+=("${root}")
370
371 cros_generate_update_payload --extract \
372 --image "${image}" \
373 --kern_path "${kernel}" --root_path "${root}" \
374 --work_dir "${FLAGS_work_dir}" --outside_chroot
375
Alex Deymo83f2f702015-10-14 14:49:33 -0700376 # Chrome OS uses major_version 1 payloads for all versions, even if the
377 # updater supports a newer major version.
378 FORCE_MAJOR_VERSION="1"
379
Tudor Brindusdda79e22018-06-28 18:03:21 -0700380 eval ${partitions_array}[kernel]=\""${kernel}"\"
381 eval ${partitions_array}[root]=\""${root}"\"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700382
Sen Jiang788c2d92016-03-09 12:48:40 -0800383 if [[ -n "${partitions_order}" ]]; then
Tudor Brindusdda79e22018-06-28 18:03:21 -0700384 eval "${partitions_order}=( \"root\" \"kernel\" )"
Sen Jiang788c2d92016-03-09 12:48:40 -0800385 fi
386
Alex Deymo89ff9e32015-09-15 19:29:01 -0700387 local part varname
Tudor Brindusdda79e22018-06-28 18:03:21 -0700388 for part in kernel root; do
Alex Deymo89ff9e32015-09-15 19:29:01 -0700389 varname="${partitions_array}[${part}]"
390 printf "md5sum of %s: " "${varname}"
391 md5sum "${!varname}"
392 done
393}
394
Sen Jiang788c2d92016-03-09 12:48:40 -0800395# extract_image_brillo <target_files.zip> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700396#
397# Extract the A/B updated partitions from a Brillo target_files zip file into
398# new temporary files.
399extract_image_brillo() {
400 local image="$1"
401 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800402 local partitions_order="${3:-}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700403
Alex Deymo48b502a2015-09-17 19:00:18 -0700404 local partitions=( "boot" "system" )
Alex Deymo168b5352015-11-04 13:51:52 -0800405 local ab_partitions_list
406 ab_partitions_list=$(create_tempfile "ab_partitions_list.XXXXXX")
407 CLEANUP_FILES+=("${ab_partitions_list}")
408 if unzip -p "${image}" "META/ab_partitions.txt" >"${ab_partitions_list}"; then
409 if grep -v -E '^[a-zA-Z0-9_-]*$' "${ab_partitions_list}" >&2; then
410 die "Invalid partition names found in the partition list."
411 fi
Sen Jiang34c711a2017-10-25 17:25:21 -0700412 # Get partition list without duplicates.
413 partitions=($(awk '!seen[$0]++' "${ab_partitions_list}"))
Alex Deymo168b5352015-11-04 13:51:52 -0800414 if [[ ${#partitions[@]} -eq 0 ]]; then
415 die "The list of partitions is empty. Can't generate a payload."
416 fi
417 else
418 warn "No ab_partitions.txt found. Using default."
419 fi
420 echo "List of A/B partitions: ${partitions[@]}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700421
Sen Jiang788c2d92016-03-09 12:48:40 -0800422 if [[ -n "${partitions_order}" ]]; then
423 eval "${partitions_order}=(${partitions[@]})"
424 fi
425
Alex Deymo83f2f702015-10-14 14:49:33 -0700426 # All Brillo updaters support major version 2.
427 FORCE_MAJOR_VERSION="2"
428
Alex Deymo48b502a2015-09-17 19:00:18 -0700429 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800430 # Source image
431 local ue_config=$(create_tempfile "ue_config.XXXXXX")
Alex Deymoc97df432015-09-25 17:23:52 -0700432 CLEANUP_FILES+=("${ue_config}")
433 if ! unzip -p "${image}" "META/update_engine_config.txt" \
434 >"${ue_config}"; then
435 warn "No update_engine_config.txt found. Assuming pre-release image, \
436using payload minor version 2"
437 fi
Alex Deymo83f2f702015-10-14 14:49:33 -0700438 # For delta payloads, we use the major and minor version supported by the
439 # old updater.
Alex Deymoc97df432015-09-25 17:23:52 -0700440 FORCE_MINOR_VERSION=$(read_option_uint "${ue_config}" \
441 "PAYLOAD_MINOR_VERSION" 2)
Alex Deymo83f2f702015-10-14 14:49:33 -0700442 FORCE_MAJOR_VERSION=$(read_option_uint "${ue_config}" \
443 "PAYLOAD_MAJOR_VERSION" 2)
Alex Deymo61e1fa82016-01-19 15:16:34 -0800444
445 # Brillo support for deltas started with minor version 3.
446 if [[ "${FORCE_MINOR_VERSION}" -le 2 ]]; then
447 warn "No delta support from minor version ${FORCE_MINOR_VERSION}. \
448Disabling deltas for this source version."
449 exit ${EX_UNSUPPORTED_DELTA}
450 fi
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800451 else
452 # Target image
453 local postinstall_config=$(create_tempfile "postinstall_config.XXXXXX")
454 CLEANUP_FILES+=("${postinstall_config}")
455 if unzip -p "${image}" "META/postinstall_config.txt" \
456 >"${postinstall_config}"; then
457 POSTINSTALL_CONFIG_FILE="${postinstall_config}"
458 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700459 fi
460
461 local part part_file temp_raw filesize
462 for part in "${partitions[@]}"; do
463 part_file=$(create_tempfile "${part}.img.XXXXXX")
464 CLEANUP_FILES+=("${part_file}")
Tao Bao07216d62018-04-11 11:36:38 -0700465
466 # For each partition, we in turn look for its image file under IMAGES/ and
467 # RADIO/ in the given target_files zip file.
468 local path path_in_zip
469 for path in IMAGES RADIO; do
470 if unzip -l "${image}" "${path}/${part}.img" >/dev/null; then
471 path_in_zip="${path}"
472 break
473 fi
474 done
475 [[ -n "${path_in_zip}" ]] || die "Failed to find ${part}.img"
476 unzip -p "${image}" "${path_in_zip}/${part}.img" >"${part_file}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700477
478 # If the partition is stored as an Android sparse image file, we need to
479 # convert them to a raw image for the update.
480 local magic=$(head --bytes=4 "${part_file}" | hexdump -e '1/1 "%.2x"')
481 if [[ "${magic}" == "3aff26ed" ]]; then
482 temp_raw=$(create_tempfile "${part}.raw.XXXXXX")
483 CLEANUP_FILES+=("${temp_raw}")
484 echo "Converting Android sparse image ${part}.img to RAW."
485 simg2img "${part_file}" "${temp_raw}"
486 # At this point, we can drop the contents of the old part_file file, but
487 # we can't delete the file because it will be deleted in cleanup.
488 true >"${part_file}"
489 part_file="${temp_raw}"
490 fi
491
Alex Deymo20bdc702016-12-07 21:07:11 -0800492 # Extract the .map file (if one is available).
493 part_map_file=$(create_tempfile "${part}.map.XXXXXX")
494 CLEANUP_FILES+=("${part_map_file}")
Tao Bao07216d62018-04-11 11:36:38 -0700495 unzip -p "${image}" "${path_in_zip}/${part}.map" >"${part_map_file}" || \
Alex Deymo20bdc702016-12-07 21:07:11 -0800496 part_map_file=""
497
Alex Deymoa479a4d2016-05-11 18:13:49 -0700498 # delta_generator only supports images multiple of 4 KiB. For target images
499 # we pad the data with zeros if needed, but for source images we truncate
500 # down the data since the last block of the old image could be padded on
501 # disk with unknown data.
Alex Deymo48b502a2015-09-17 19:00:18 -0700502 filesize=$(stat -c%s "${part_file}")
503 if [[ $(( filesize % 4096 )) -ne 0 ]]; then
Alex Deymoa479a4d2016-05-11 18:13:49 -0700504 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
505 echo "Rounding DOWN partition ${part}.img to a multiple of 4 KiB."
506 : $(( filesize = filesize & -4096 ))
Alex Deymo04c23052017-04-12 18:15:30 -0700507 if [[ ${filesize} == 0 ]]; then
508 echo "Source partition ${part}.img is empty after rounding down," \
509 "skipping."
510 continue
511 fi
Alex Deymoa479a4d2016-05-11 18:13:49 -0700512 else
513 echo "Rounding UP partition ${part}.img to a multiple of 4 KiB."
514 : $(( filesize = (filesize + 4095) & -4096 ))
515 fi
Sen Jiangd0e9a892016-07-22 16:28:07 -0700516 truncate_file "${part_file}" "${filesize}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700517 fi
518
519 eval "${partitions_array}[\"${part}\"]=\"${part_file}\""
Alex Deymo20bdc702016-12-07 21:07:11 -0800520 eval "${partitions_array}_MAP[\"${part}\"]=\"${part_map_file}\""
Alex Deymo48b502a2015-09-17 19:00:18 -0700521 echo "Extracted ${partitions_array}[${part}]: ${filesize} bytes"
522 done
523}
524
Tudor Brindusb432db82018-06-29 13:13:27 -0700525extract_payload_images() {
526 local payload_type=$1
527 echo "Extracting images for ${payload_type} update."
528
529 if [[ "${payload_type}" == "delta" ]]; then
530 extract_image "${FLAGS_source_image}" SRC_PARTITIONS
531 fi
532 extract_image "${FLAGS_target_image}" DST_PARTITIONS PARTITIONS_ORDER
533}
534
535get_payload_type() {
536 if [[ -z "${FLAGS_source_image}" ]]; then
537 echo "full"
538 else
539 echo "delta"
540 fi
541}
542
Jason Kusumabe998f42015-09-03 15:53:13 -0700543validate_generate() {
544 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700545 die "You must specify an output filename with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700546
547 [[ -n "${FLAGS_target_image}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700548 die "You must specify a target image with --target_image FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700549}
550
551cmd_generate() {
Alex Deymo89ff9e32015-09-15 19:29:01 -0700552 local payload_type="delta"
Jason Kusumabe998f42015-09-03 15:53:13 -0700553 if [[ -z "${FLAGS_source_image}" ]]; then
Alex Deymo89ff9e32015-09-15 19:29:01 -0700554 payload_type="full"
Jason Kusumabe998f42015-09-03 15:53:13 -0700555 fi
556
Alex Deymo48b502a2015-09-17 19:00:18 -0700557 echo "Extracting images for ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700558
Sen Jiang788c2d92016-03-09 12:48:40 -0800559 extract_image "${FLAGS_target_image}" DST_PARTITIONS PARTITIONS_ORDER
Alex Deymo89ff9e32015-09-15 19:29:01 -0700560 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo48b502a2015-09-17 19:00:18 -0700561 extract_image "${FLAGS_source_image}" SRC_PARTITIONS
Jason Kusumabe998f42015-09-03 15:53:13 -0700562 fi
563
Alex Deymo48b502a2015-09-17 19:00:18 -0700564 echo "Generating ${payload_type} update."
Alex Deymo168b5352015-11-04 13:51:52 -0800565 # Common payload args:
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700566 GENERATOR_ARGS=( --out_file="${FLAGS_payload}" )
Alex Deymo168b5352015-11-04 13:51:52 -0800567
568 local part old_partitions="" new_partitions="" partition_names=""
Alex Deymo20bdc702016-12-07 21:07:11 -0800569 local old_mapfiles="" new_mapfiles=""
Sen Jiang788c2d92016-03-09 12:48:40 -0800570 for part in "${PARTITIONS_ORDER[@]}"; do
Alex Deymo168b5352015-11-04 13:51:52 -0800571 if [[ -n "${partition_names}" ]]; then
572 partition_names+=":"
573 new_partitions+=":"
574 old_partitions+=":"
Alex Deymo20bdc702016-12-07 21:07:11 -0800575 new_mapfiles+=":"
576 old_mapfiles+=":"
Alex Deymo168b5352015-11-04 13:51:52 -0800577 fi
578 partition_names+="${part}"
579 new_partitions+="${DST_PARTITIONS[${part}]}"
580 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800581 new_mapfiles+="${DST_PARTITIONS_MAP[${part}]:-}"
582 old_mapfiles+="${SRC_PARTITIONS_MAP[${part}]:-}"
Alex Deymo168b5352015-11-04 13:51:52 -0800583 done
584
585 # Target image args:
586 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700587 --partition_names="${partition_names}"
588 --new_partitions="${new_partitions}"
589 --new_mapfiles="${new_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700590 )
591
Alex Deymo89ff9e32015-09-15 19:29:01 -0700592 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo168b5352015-11-04 13:51:52 -0800593 # Source image args:
Jason Kusumabe998f42015-09-03 15:53:13 -0700594 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700595 --old_partitions="${old_partitions}"
596 --old_mapfiles="${old_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700597 )
Alex Deymo48b502a2015-09-17 19:00:18 -0700598 if [[ -n "${FORCE_MINOR_VERSION}" ]]; then
599 GENERATOR_ARGS+=( --minor_version="${FORCE_MINOR_VERSION}" )
600 fi
601 fi
602
603 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
604 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
Jason Kusumabe998f42015-09-03 15:53:13 -0700605 fi
606
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700607 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
608 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
609 fi
610
Sen Jiang8e768e92017-06-28 17:13:19 -0700611 if [[ -n "${FLAGS_max_timestamp}" ]]; then
612 GENERATOR_ARGS+=( --max_timestamp="${FLAGS_max_timestamp}" )
613 fi
614
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800615 if [[ -n "${POSTINSTALL_CONFIG_FILE}" ]]; then
616 GENERATOR_ARGS+=(
617 --new_postinstall_config_file="${POSTINSTALL_CONFIG_FILE}"
618 )
619 fi
620
Jason Kusumabe998f42015-09-03 15:53:13 -0700621 echo "Running delta_generator with args: ${GENERATOR_ARGS[@]}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700622 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700623
Alex Deymo89ff9e32015-09-15 19:29:01 -0700624 echo "Done generating ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700625}
626
627validate_hash() {
628 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700629 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700630
631 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700632 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700633--unsigned_payload FILENAME"
634
Jason Kusumabe998f42015-09-03 15:53:13 -0700635 [[ -n "${FLAGS_payload_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700636 die "You must specify --payload_hash_file FILENAME"
Jason Kusumaf514c542015-11-05 18:43:45 -0800637
638 [[ -n "${FLAGS_metadata_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700639 die "You must specify --metadata_hash_file FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700640}
641
642cmd_hash() {
Sen Jiangbf1266f2015-10-26 11:29:24 -0700643 "${GENERATOR}" \
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700644 --in_file="${FLAGS_unsigned_payload}" \
645 --signature_size="${FLAGS_signature_size}" \
646 --out_hash_file="${FLAGS_payload_hash_file}" \
647 --out_metadata_hash_file="${FLAGS_metadata_hash_file}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700648
Jason Kusumabe998f42015-09-03 15:53:13 -0700649 echo "Done generating hash."
650}
651
652validate_sign() {
653 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700654 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700655
656 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700657 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700658--unsigned_payload FILENAME"
659
660 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700661 die "You must specify the output signed payload with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700662
663 [[ -n "${FLAGS_payload_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700664 die "You must specify the payload signature file with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700665--payload_signature_file SIGNATURES"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700666
667 [[ -n "${FLAGS_metadata_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700668 die "You must specify the metadata signature file with \
Alex Deymo89ff9e32015-09-15 19:29:01 -0700669--metadata_signature_file SIGNATURES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700670}
671
672cmd_sign() {
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700673 GENERATOR_ARGS=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700674 --in_file="${FLAGS_unsigned_payload}"
675 --signature_size="${FLAGS_signature_size}"
676 --payload_signature_file="${FLAGS_payload_signature_file}"
677 --metadata_signature_file="${FLAGS_metadata_signature_file}"
678 --out_file="${FLAGS_payload}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700679 )
680
681 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
682 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
683 fi
684
685 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700686 echo "Done signing payload."
687}
688
Alex Deymo98e691c2016-02-04 21:05:45 -0800689validate_properties() {
690 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700691 die "You must specify the payload file with --payload FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800692
693 [[ -n "${FLAGS_properties_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700694 die "You must specify a non empty --properties_file FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800695}
696
697cmd_properties() {
698 "${GENERATOR}" \
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700699 --in_file="${FLAGS_payload}" \
700 --properties_file="${FLAGS_properties_file}"
Alex Deymo98e691c2016-02-04 21:05:45 -0800701}
702
Tudor Brindusb432db82018-06-29 13:13:27 -0700703validate_verify_and_check() {
Amin Hassani13520932017-07-26 11:26:05 -0700704 [[ -n "${FLAGS_payload}" ]] ||
705 die "Error: you must specify an input filename with --payload FILENAME"
706
707 [[ -n "${FLAGS_target_image}" ]] ||
708 die "Error: you must specify a target image with --target_image FILENAME"
709}
710
711cmd_verify() {
Tudor Brindusb432db82018-06-29 13:13:27 -0700712 local payload_type=$(get_payload_type)
713 extract_payload_images ${payload_type}
Amin Hassani13520932017-07-26 11:26:05 -0700714
715 declare -A TMP_PARTITIONS
716 for part in "${PARTITIONS_ORDER[@]}"; do
717 local tmp_part=$(create_tempfile "tmp_part.bin.XXXXXX")
718 echo "Creating temporary target partition ${tmp_part} for ${part}"
719 CLEANUP_FILES+=("${tmp_part}")
720 TMP_PARTITIONS[${part}]=${tmp_part}
721 local FILESIZE=$(stat -c%s "${DST_PARTITIONS[${part}]}")
722 echo "Truncating ${TMP_PARTITIONS[${part}]} to ${FILESIZE}"
723 truncate_file "${TMP_PARTITIONS[${part}]}" "${FILESIZE}"
724 done
725
726 echo "Verifying ${payload_type} update."
727 # Common payload args:
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700728 GENERATOR_ARGS=( --in_file="${FLAGS_payload}" )
Amin Hassani13520932017-07-26 11:26:05 -0700729
730 local part old_partitions="" new_partitions="" partition_names=""
731 for part in "${PARTITIONS_ORDER[@]}"; do
732 if [[ -n "${partition_names}" ]]; then
733 partition_names+=":"
734 new_partitions+=":"
735 old_partitions+=":"
736 fi
737 partition_names+="${part}"
738 new_partitions+="${TMP_PARTITIONS[${part}]}"
739 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
740 done
741
742 # Target image args:
743 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700744 --partition_names="${partition_names}"
745 --new_partitions="${new_partitions}"
Amin Hassani13520932017-07-26 11:26:05 -0700746 )
747
748 if [[ "${payload_type}" == "delta" ]]; then
749 # Source image args:
750 GENERATOR_ARGS+=(
Tudor Brindus5ec5bd12018-07-11 11:02:44 -0700751 --old_partitions="${old_partitions}"
Amin Hassani13520932017-07-26 11:26:05 -0700752 )
753 fi
754
Amin Hassania566cb62017-08-23 12:36:55 -0700755 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
756 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
757 fi
758
Amin Hassani13520932017-07-26 11:26:05 -0700759 echo "Running delta_generator to verify ${payload_type} payload with args: \
760${GENERATOR_ARGS[@]}"
761 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
762
763 if [[ $? -eq 0 ]]; then
764 echo "Done applying ${payload_type} update."
765 echo "Checking the newly generated partitions against the target partitions"
766 for part in "${PARTITIONS_ORDER[@]}"; do
767 cmp "${TMP_PARTITIONS[${part}]}" "${DST_PARTITIONS[${part}]}"
768 local not_str=""
769 if [[ $? -ne 0 ]]; then
770 not_str="in"
771 fi
772 echo "The new partition (${part}) is ${not_str}valid."
773 done
774 else
775 echo "Failed to apply ${payload_type} update."
776 fi
777}
778
Tudor Brindusb432db82018-06-29 13:13:27 -0700779cmd_check() {
780 local payload_type=$(get_payload_type)
781 extract_payload_images ${payload_type}
782
783 local part dst_partitions="" src_partitions=""
784 for part in "${PARTITIONS_ORDER[@]}"; do
785 if [[ -n "${dst_partitions}" ]]; then
786 dst_partitions+=" "
787 src_partitions+=" "
788 fi
789 dst_partitions+="${DST_PARTITIONS[${part}]}"
790 src_partitions+="${SRC_PARTITIONS[${part}]:-}"
791 done
792
793 # Common payload args:
794 PAYCHECK_ARGS=( "${FLAGS_payload}" --type ${payload_type} \
795 --part_names ${PARTITIONS_ORDER[@]} \
796 --dst_part_paths ${dst_partitions} )
797
798 if [[ ! -z "${SRC_PARTITIONS[@]}" ]]; then
799 PAYCHECK_ARGS+=( --src_part_paths ${src_partitions} )
800 fi
801
802 echo "Checking ${payload_type} update."
803 check_update_payload ${PAYCHECK_ARGS[@]} --check
804}
805
Jason Kusumabe998f42015-09-03 15:53:13 -0700806# Sanity check that the real generator exists:
Sen Jiang13519752016-08-02 16:10:52 -0700807GENERATOR="$(which delta_generator || true)"
Jason Kusumabe998f42015-09-03 15:53:13 -0700808[[ -x "${GENERATOR}" ]] || die "can't find delta_generator"
809
810case "$COMMAND" in
811 generate) validate_generate
812 cmd_generate
813 ;;
814 hash) validate_hash
815 cmd_hash
816 ;;
817 sign) validate_sign
818 cmd_sign
819 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800820 properties) validate_properties
821 cmd_properties
822 ;;
Tudor Brindusb432db82018-06-29 13:13:27 -0700823 verify) validate_verify_and_check
Amin Hassani13520932017-07-26 11:26:05 -0700824 cmd_verify
825 ;;
Tudor Brindusb432db82018-06-29 13:13:27 -0700826 check) validate_verify_and_check
827 cmd_check
828 ;;
Jason Kusumabe998f42015-09-03 15:53:13 -0700829esac